﻿using Syncfusion.UI.Xaml.Grid;
using Syncfusion.UI.Xaml.Grid.Cells;
using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Syncfusion.Windows.Shared;

namespace Support_128338
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.sfdatagrid.CellRenderers.Remove("Numeric");
            this.sfdatagrid.CellRenderers.Add("Numeric", new GridNumericColumnRendererExt());
        }
    }

    public class DecimalDigitConverter : IValueConverter
    {
        object IValueConverter.Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value != null && (value as Model) != null)
            {
                int decimalDegits = (value as Model).NumberOfDecimals;
                if (decimalDegits == 0)
                    return Math.Floor((value as Model).Value);
                else
                    return Math.Round((value as Model).Value,2);
            }
            return null;
        }
        object IValueConverter.ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return value;
        }
    }

    public class GridNumericColumnRendererExt : GridCellNumericRenderer
    {
        public override void OnInitializeEditElement(DataColumnBase dataColumn, DoubleTextBox uiElement, object dataContext)
        {
            if (dataColumn.GridColumn.MappingName == "Value")
            {
                int decimalDegits = (dataContext as Model).NumberOfDecimals;
                if (decimalDegits == 0)
                {
                    uiElement.Value = Math.Floor((dataContext as Model).Value);
                    uiElement.NumberDecimalDigits = 0;
                }
                else
                {
                    uiElement.Value = Math.Round((dataContext as Model).Value, 2);
                    uiElement.NumberDecimalDigits = 2;
                }
                var column = dataColumn.GridColumn;
                var textPadding = new Binding { Path = new PropertyPath("Padding"), Mode = BindingMode.OneWay, Source = column };
                uiElement.SetBinding(Control.PaddingProperty, textPadding);
                var textAlignBind = new Binding { Path = new PropertyPath("TextAlignment"), Mode = BindingMode.TwoWay, Source = column };
                uiElement.SetBinding(TextBox.TextAlignmentProperty, textAlignBind);
                var textWrappingBinding = new Binding { Path = new PropertyPath("TextWrapping"), Mode = BindingMode.TwoWay, Source = column };
                uiElement.SetBinding(TextBox.TextWrappingProperty, textWrappingBinding);
                var verticalContentAlignment = new Binding { Path = new PropertyPath("VerticalAlignment"), Mode = BindingMode.TwoWay, Source = column };
                uiElement.SetBinding(Control.VerticalContentAlignmentProperty, verticalContentAlignment);
                var textDecorations = new Binding { Path = new PropertyPath("TextDecorations"), Mode = BindingMode.TwoWay, Source = column };
                uiElement.SetBinding(TextBox.TextDecorationsProperty, textDecorations);
            }
        }
    }
}
